config/routes.rb
# Plugin's routes
# See: http://guides.rubyonrails.org/routing.html
resources :goals
resources :user_goals

app/models/goal.rb
class Goal < ActiveRecord::Base
  belongs_to :project, foreign_key: 'project_id', primary_key: 'identifier'
  belongs_to :author, class_name: 'User', foreign_key: 'author_id'

  validates :author, :start_time, :end_time, :name, :description, presence: true

  enum status: { open: 0, doing: 1, pending: 2, done: 3, close: 4 }

  def percent_of_doing_time
    current_time_value = (Time.current.to_date - start_time.to_date).to_i + 1
    end_time_value = (end_time.to_date - start_time.to_date).to_i + 1
    percent = (current_time_value.to_f / end_time_value.to_f) * 100
    percent.to_i
  end
end

app/controllers/goals_controller.rb
class GoalsController < ApplicationController
  before_action :find_project
  before_action :authorize

  def index
    @goals = Goal.where(project: @project)
  end

  def new
    @goal = Goal.new
  end

  def show
    @goal = Goal.find(params[:id])
  end

  def edit
    @goal = Goal.find(params[:id])
  end

  def update
    @goal = Goal.find(params[:id])
    @goal.assign_attributes(params[:goal].permit!)
    if @goal.valid?
      @goal.save
      redirect_to goal_path(@goal, project_id: @goal.project_id), notice: 'Successful update.'
    else
      render :edit
    end
  end

  def create
    @goal = Goal.new(author: User.current)
    @goal.assign_attributes(params[:goal].permit!)
    if @goal.valid?
      @goal.save
      redirect_to goals_path(project_id: params[:project_id]), notice: 'Successful create.'
    else
      render :new
    end
  end

  private

  def find_project
  	@project = Project.find(params[:project_id])
  end
end

app/controllers/user_goals_controller.rb
class UserGoalsController < ApplicationController
  before_action :require_login
  before_action :current_user

  def index
    @goals = Goal.where(author: current_user)
  end

  def new
    @goal = Goal.new(author: current_user)
  end

  def create
    @goal = Goal.new(author: current_user)
    @goal.assign_attributes(goal_params)

    if @goal.valid?
      @goal.save
      redirect_to user_goals_path, notice: 'Successful create.'
    else
      render :new
    end  
  end

  def show
    @goal = Goal.find(params[:id])
  end

  def update
    @goal = Goal.find(params[:id])
    @goal.assign_attributes(goal_params)

    if @goal.valid?
      @goal.save
      redirect_to user_goal_path(@goal), notice: 'Successful update.'
    else
      render :edit
    end  
  end

  def edit
    @goal = Goal.find(params[:id])
  end

  private

  def current_user
    @user = User.current
  end

  def goal_params
    params.require(:goal).permit!
  end
end

app/helpers/goals_helper.rb
module GoalsHelper
end

app/helpers/user_goals_helper.rb
module UserGoalsHelper
end

app/views/commons/_form.html.slim
= form_for goal, url: url do |form|
  - if goal.errors.any?
    #errorExplanation
      ul
        - goal.errors.full_messages.each do |msg|
          li= msg
  .box.tabular.filedroplistner
    = hidden_field_tag :project_id, params[:project_id]
    #all_attributes
      = form.hidden_field :project_id, value: params[:project_id]
      p
        = form.label :name
        = form.text_field :name
      p
        = form.label :status
        = form.select :status, options_for_select(Goal.statuses.keys, form.object.status)
      p
        = form.label :description
        span#issue_description_and_toolbar
          = form.text_area :description, cols: 60, rows: 10
          = wikitoolbar_for 'goal_description'
      p
        = form.label :start_time
        = form.text_field :start_time, type: 'date', value: goal.start_time.try(:to_date)
        = calendar_for('goal_start_time')
      p
        = form.label :end_time
        = form.text_field :end_time, type: 'date', value: goal.end_time.try(:to_date)
        = calendar_for('goal_end_time')
      p
        = form.submit :submit

app/views/commons/_goal-detail.html.slim
.issue
  .subject
    h3.value
      span.showValue #{goal.name}
  p.author
    | Added by #{goal.author.name}
  .attributes
    .splitcontent
      .splitcontentleft
        .attribute
          .label
            span Status:
          .value
            span
              strong= goal.status
        .attribute
          .label
            span Start time:
          .value
            span= format_time(goal.start_time)
        .attribute
          .label
            span End time:
          .value
            span= format_time(goal.end_time)
      .splitcontentright
        .attribute
          .label
            span Time consume:
          .value
            = progress_bar(goal.percent_of_doing_time, legend: "#{goal.percent_of_doing_time}%")
        .description
          p
            strong Description:
          .wiki.issue
            = textilizable(goal, :description)

app/views/goals/_goals_overview.html.erb
<h2>Message from Hook!</h2>
<p>total goals:
	<%= goals_size %>
</p>

app/views/goals/edit.html.slim
#content
  h2 Edit goal
  = render 'commons/form', goal: @goal, url: goal_path(@goal)

app/views/goals/index.html.slim
#content
  .contextual
    = link_to 'new goal', new_goal_path(project_id: params[:project_id]), class: 'icon icon-add new-issue'
  h2 Goals
  .splitcontent
    .splitcontentleft
      .issues.box
        table.list
          thead
            tr
              th Id
              th Name
              th Status
              th Start
              th End
              th Author name
              th Project name
          tbody
            - @goals.each do |goal|
              tr
                td= link_to goal.id, goal_path(goal, project_id: goal.project_id), target: '_blank'
                td= goal.name
                td= goal.status
                td= format_time(goal.start_time)
                td= format_time(goal.end_time)
                td= goal.author.name
                td= goal.project.name

app/views/goals/new.html.slim
#content
  h2 New goal
  = render 'commons/form', goal: @goal, url: goals_path

app/views/goals/show.html.slim
#content
  .contextual
    = link_to 'Edit', edit_goal_path(@goal, project_id: @goal.project_id), class: 'icon icon-edit'
  h2 goal ##{@goal.id}
  
  #goal-detail
    = render 'commons/goal-detail', goal: @goal

app/views/user_goals/edit.html.slim
#content
  h2 Edit goal
  = render 'commons/form', goal: @goal, url: user_goal_path(@goal)

app/views/user_goals/index.html.slim
#content
  .contextual
    = link_to 'new goal', new_user_goal_path, class: 'icon icon-add new-issue'
  h2 Goals
  .splitcontent
    .splitcontentleft
      .issues.box
        table.list
          thead
            tr
              th Id
              th Name
              th Status
              th Start
              th End
              th Author name
              th Project name
          tbody
            - @goals.each do |goal|
              tr
                td= link_to goal.id, user_goal_path(goal), target: '_blank'
                td= goal.name
                td= goal.status
                td= format_time(goal.start_time)
                td= format_time(goal.end_time)
                td
                  = progress_bar(goal.percent_of_doing_time)
                  p.percent
                    | #{goal.percent_of_doing_time}%
                td= goal.author.name
                td
                  - if goal.project.present?
                    = link_to goal.project&.name, project_path(goal.project)

app/views/user_goals/new.html.slim
#content
  h2 New goal
  = render 'commons/form', goal: @goal, url: user_goals_path

app/views/user_goals/show.html.slim
#content
  .contextual
    = link_to 'Edit', edit_user_goal_path(@goal), class: 'icon icon-edit'
  h2 goal ##{@goal.id}
  
  #goal-detail
    = render 'commons/goal-detail', goal: @goal